Index: asp3_gr_sakura/trunk/tecs_kernel/kernel.cdl
===================================================================
--- asp3_gr_sakura/trunk/tecs_kernel/kernel.cdl	(revision 318)
+++ asp3_gr_sakura/trunk/tecs_kernel/kernel.cdl	(revision 319)
@@ -9,47 +9,32 @@
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
- *  ä¸è¨èä½æ¨©è
-ã¯ï¼ä»¥ä¸ã®(1)ï½(4)ã®æ¡ä»¶ãæºããå ´åã«éãï¼æ¬ã½ããã¦ã§
- *  ã¢ï¼æ¬ã½ããã¦ã§ã¢ãæ¹å¤ãããã®ãå«ãï¼ä»¥ä¸åãï¼ãä½¿ç¨ã»è¤è£½ã»æ¹
- *  å¤ã»åé
-å¸ï¼ä»¥ä¸ï¼å©ç¨ã¨å¼ã¶ï¼ãããã¨ãç¡åã§è¨±è«¾ããï¼
- *  (1) æ¬ã½ããã¦ã§ã¢ãã½ã¼ã¹ã³ã¼ãã®å½¢ã§å©ç¨ããå ´åã«ã¯ï¼ä¸è¨ã®èä½
- *      æ¨©è¡¨ç¤ºï¼ãã®å©ç¨æ¡ä»¶ããã³ä¸è¨ã®ç¡ä¿è¨¼è¦å®ãï¼ãã®ã¾ã¾ã®å½¢ã§ã½ã¼
- *      ã¹ã³ã¼ãä¸­ã«å«ã¾ãã¦ãããã¨ï¼
- *  (2) æ¬ã½ããã¦ã§ã¢ãï¼ã©ã¤ãã©ãªå½¢å¼ãªã©ï¼ä»ã®ã½ããã¦ã§ã¢éçºã«ä½¿
- *      ç¨ã§ããå½¢ã§åé
-å¸ããå ´åã«ã¯ï¼åé
-å¸ã«ä¼´ããã­ã¥ã¡ã³ãï¼å©ç¨
- *      è
-ããã¥ã¢ã«ãªã©ï¼ã«ï¼ä¸è¨ã®èä½æ¨©è¡¨ç¤ºï¼ãã®å©ç¨æ¡ä»¶ããã³ä¸è¨
- *      ã®ç¡ä¿è¨¼è¦å®ãæ²è¼ãããã¨ï¼
- *  (3) æ¬ã½ããã¦ã§ã¢ãï¼æ©å¨ã«çµã¿è¾¼ããªã©ï¼ä»ã®ã½ããã¦ã§ã¢éçºã«ä½¿
- *      ç¨ã§ããªãå½¢ã§åé
-å¸ããå ´åã«ã¯ï¼æ¬¡ã®ããããã®æ¡ä»¶ãæºããã
- *      ã¨ï¼
- *    (a) åé
-å¸ã«ä¼´ããã­ã¥ã¡ã³ãï¼å©ç¨è
-ããã¥ã¢ã«ãªã©ï¼ã«ï¼ä¸è¨ã®è
- *        ä½æ¨©è¡¨ç¤ºï¼ãã®å©ç¨æ¡ä»¶ããã³ä¸è¨ã®ç¡ä¿è¨¼è¦å®ãæ²è¼ãããã¨ï¼
- *    (b) åé
-å¸ã®å½¢æ
-ãï¼å¥ã«å®ããæ¹æ³ã«ãã£ã¦ï¼TOPPERSãã­ã¸ã§ã¯ãã«
- *        å ±åãããã¨ï¼
- *  (4) æ¬ã½ããã¦ã§ã¢ã®å©ç¨ã«ããç´æ¥çã¾ãã¯éæ¥çã«çãããããªãæ
- *      å®³ãããï¼ä¸è¨èä½æ¨©è
-ããã³TOPPERSãã­ã¸ã§ã¯ããå
-è²¬ãããã¨ï¼
- *      ã¾ãï¼æ¬ã½ããã¦ã§ã¢ã®ã¦ã¼ã¶ã¾ãã¯ã¨ã³ãã¦ã¼ã¶ããã®ãããªãç
- *      ç±ã«åºã¥ãè«æ±ãããï¼ä¸è¨èä½æ¨©è
-ããã³TOPPERSãã­ã¸ã§ã¯ãã
- *      å
-è²¬ãããã¨ï¼
+ *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
+ *  ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
+ *  変・再配布（以下，利用と呼ぶ）することを無償で許諾する．
+ *  (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作
+ *      権表示，この利用条件および下記の無保証規定が，そのままの形でソー
+ *      スコード中に含まれていること．
+ *  (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使
+ *      用できる形で再配布する場合には，再配布に伴うドキュメント（利用
+ *      者マニュアルなど）に，上記の著作権表示，この利用条件および下記
+ *      の無保証規定を掲載すること．
+ *  (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使
+ *      用できない形で再配布する場合には，次のいずれかの条件を満たすこ
+ *      と．
+ *    (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著
+ *        作権表示，この利用条件および下記の無保証規定を掲載すること．
+ *    (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに
+ *        報告すること．
+ *  (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損
+ *      害からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
+ *      また，本ソフトウェアのユーザまたはエンドユーザからのいかなる理
+ *      由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
+ *      免責すること．
  * 
- *  æ¬ã½ããã¦ã§ã¢ã¯ï¼ç¡ä¿è¨¼ã§æä¾ããã¦ãããã®ã§ããï¼ä¸è¨èä½æ¨©è
-ã
- *  ãã³TOPPERSãã­ã¸ã§ã¯ãã¯ï¼æ¬ã½ããã¦ã§ã¢ã«é¢ãã¦ï¼ç¹å®ã®ä½¿ç¨ç®ç
- *  ã«å¯¾ããé©åæ§ãå«ãã¦ï¼ãããªãä¿è¨¼ãè¡ããªãï¼ã¾ãï¼æ¬ã½ããã¦ã§
- *  ã¢ã®å©ç¨ã«ããç´æ¥çã¾ãã¯éæ¥çã«çãããããªãæå®³ã«é¢ãã¦ãï¼ã
- *  ã®è²¬ä»»ãè² ããªãï¼
+ *  本ソフトウェアは，無保証で提供されているものである．上記著作権者お
+ *  よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
+ *  に対する適合性も含めて，いかなる保証も行わない．また，本ソフトウェ
+ *  アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
+ *  の責任を負わない．
  * 
  *  $Id$
@@ -57,14 +42,14 @@
 
 /*
- *		TOPPERS/ASPã«ã¼ãã«ãªãã¸ã§ã¯ã ã³ã³ãã¼ãã³ãè¨è¿°ãã¡ã¤ã«
- */
-
-/*
- *  ã«ã¼ãã«ãªãã¸ã§ã¯ãã®ã³ã³ãã¼ãã³ãåã®ããã®ããããã¡ã¤ã«
+ *		TOPPERS/ASPカーネルオブジェクト コンポーネント記述ファイル
+ */
+
+/*
+ *  カーネルオブジェクトのコンポーネント化のためのヘッダファイル
  */
 import_C("tecs_kernel.h");
 
 /*
- *  ã«ã¼ãã«æä½ã®ã·ã°ããã£ï¼ã¿ã¹ã¯ã³ã³ãã­ã¹ãç¨ï¼
+ *  カーネル操作のシグニチャ（タスクコンテキスト用）
  */
 signature sKernel {
@@ -106,5 +91,5 @@
 
 /*
- *  ã«ã¼ãã«æä½ã®ã·ã°ããã£ï¼éã¿ã¹ã¯ã³ã³ãã­ã¹ãç¨ï¼
+ *  カーネル操作のシグニチャ（非タスクコンテキスト用）
  */
 [context("non-task")]
@@ -123,5 +108,5 @@
 	ER		exitKernel(void);
 
-	/* CPUä¾å¤ãã³ãã©ä¸­ã§ä½¿ç¨ãã */
+	/* CPU例外ハンドラ中で使用する */
 	bool_t	exceptionSenseDispatchPendingState
 						([in] const void *p_exceptionInformation);
@@ -129,5 +114,5 @@
 
 /*
- *  ã«ã¼ãã«ã®ã»ã«ã¿ã¤ã
+ *  カーネルのセルタイプ
  */
 [singleton]
@@ -138,5 +123,5 @@
 
 /*
- *  ã¿ã¤ã ã¤ãã³ãéç¥ãåãåãããã®ã·ã°ããã£
+ *  タイムイベント通知を受け取るためのシグネチャ
  */
 [context("non-task")]
@@ -145,5 +130,5 @@
 
 /*
- *  ã¿ã¹ã¯æ¬ä½ã®ã·ã°ããã£
+ *  タスク本体のシグニチャ
  */
 signature sTaskBody {
@@ -152,5 +137,5 @@
 
 /*
- *  ã¿ã¹ã¯æä½ã®ã·ã°ããã£ï¼ã¿ã¹ã¯ã³ã³ãã­ã¹ãç¨ï¼
+ *  タスク操作のシグニチャ（タスクコンテキスト用）
  */
 signature sTask {
@@ -173,5 +158,5 @@
 
 /*
- *  ã¿ã¹ã¯æä½ã®ã·ã°ããã£ï¼éã¿ã¹ã¯ã³ã³ãã­ã¹ãç¨ï¼
+ *  タスク操作のシグニチャ（非タスクコンテキスト用）
  */
 [context("non-task")]
@@ -183,5 +168,5 @@
 
 /*
- *  ã¿ã¹ã¯ã®ã»ã«ã¿ã¤ã
+ *  タスクのセルタイプ
  */
 [active]
@@ -213,5 +198,5 @@
 
 /*
- *  ã»ããã©æä½ã®ã·ã°ããã£ï¼ã¿ã¹ã¯ã³ã³ãã­ã¹ãç¨ï¼
+ *  セマフォ操作のシグニチャ（タスクコンテキスト用）
  */
 signature sSemaphore {
@@ -225,5 +210,5 @@
 
 /*
- *  ã»ããã©æä½ã®ã·ã°ããã£ï¼éã¿ã¹ã¯ã³ã³ãã­ã¹ãç¨ï¼
+ *  セマフォ操作のシグニチャ（非タスクコンテキスト用）
  */
 [context("non-task")]
@@ -233,5 +218,5 @@
 
 /*
- *  ã»ããã©ã®ã»ã«ã¿ã¤ã
+ *  セマフォのセルタイプ
  */
 celltype tSemaphore {
@@ -258,5 +243,5 @@
 
 /*
- *  ã¤ãã³ããã©ã°æä½ã®ã·ã°ããã£ï¼ã¿ã¹ã¯ã³ã³ãã­ã¹ãç¨ï¼
+ *  イベントフラグ操作のシグニチャ（タスクコンテキスト用）
  */
 signature sEventflag {
@@ -274,5 +259,5 @@
 
 /*
- *  ã¤ãã³ããã©ã°æä½ã®ã·ã°ããã£ï¼éã¿ã¹ã¯ã³ã³ãã­ã¹ãç¨ï¼
+ *  イベントフラグ操作のシグニチャ（非タスクコンテキスト用）
  */
 [context("non-task")]
@@ -282,5 +267,5 @@
 
 /*
- *  ã¤ãã³ããã©ã°ã®ã»ã«ã¿ã¤ã
+ *  イベントフラグのセルタイプ
  */
 celltype tEventflag {
@@ -306,5 +291,5 @@
 
 /*
- *  ãã¼ã¿ã­ã¥ã¼æä½ã®ã·ã°ããã£ï¼ã¿ã¹ã¯ã³ã³ãã­ã¹ãç¨ï¼
+ *  データキュー操作のシグニチャ（タスクコンテキスト用）
  */
 signature sDataqueue {
@@ -321,5 +306,5 @@
 
 /*
- *  ãã¼ã¿ã­ã¥ã¼æä½ã®ã·ã°ããã£ï¼éã¿ã¹ã¯ã³ã³ãã­ã¹ãç¨ï¼
+ *  データキュー操作のシグニチャ（非タスクコンテキスト用）
  */
 [context("non-task")]
@@ -330,5 +315,5 @@
 
 /*
- *  ãã¼ã¿ã­ã¥ã¼ã®ã»ã«ã¿ã¤ã
+ *  データキューのセルタイプ
  */
 celltype tDataqueue {
@@ -355,6 +340,5 @@
 
 /*
- *  åªå
-åº¦ãã¼ã¿ã­ã¥ã¼æä½ã®ã·ã°ããã£ï¼ã¿ã¹ã¯ã³ã³ãã­ã¹ãç¨ï¼
+ *  優先度データキュー操作のシグニチャ（タスクコンテキスト用）
  */
 signature sPriorityDataqueue {
@@ -372,6 +356,5 @@
 
 /*
- *  åªå
-åº¦ãã¼ã¿ã­ã¥ã¼æä½ã®ã·ã°ããã£ï¼éã¿ã¹ã¯ã³ã³ãã­ã¹ãç¨ï¼
+ *  優先度データキュー操作のシグニチャ（非タスクコンテキスト用）
  */
 [context("non-task")]
@@ -381,6 +364,5 @@
 
 /*
- *  åªå
-åº¦ãã¼ã¿ã­ã¥ã¼ã®ã»ã«ã¿ã¤ã
+ *  優先度データキューのセルタイプ
  */
 celltype tPriorityDataqueue {
@@ -407,5 +389,5 @@
 
 /*
- *  ãã¥ã¼ããã¯ã¹æä½ã®ã·ã°ããã£ï¼ã¿ã¹ã¯ã³ã³ãã­ã¹ãç¨ï¼
+ *  ミューテックス操作のシグニチャ（タスクコンテキスト用）
  */
 signature sMutex {
@@ -419,5 +401,5 @@
 
 /*
- *  ãã¥ã¼ããã¯ã¹ã®ã»ã«ã¿ã¤ã
+ *  ミューテックスのセルタイプ
  */
 celltype tMutex {
@@ -440,5 +422,5 @@
 
 /*
- *  åºå®é·ã¡ã¢ãªã¡ã¢ãªãã¼ã«æä½ã®ã·ã°ããã£ï¼ã¿ã¹ã¯ã³ã³ãã­ã¹ãç¨ï¼
+ *  固定長メモリメモリプール操作のシグニチャ（タスクコンテキスト用）
  */
 [deviate]
@@ -453,5 +435,5 @@
 
 /*
- *  åºå®é·ã¡ã¢ãªãã¼ã«ã®ã»ã«ã¿ã¤ã
+ *  固定長メモリプールのセルタイプ
  */
 celltype tFixedSizeMemoryPool {
@@ -478,5 +460,5 @@
 
 /*
- *  ãã³ãã©æ¬ä½ã®ã·ã°ããã£
+ *  ハンドラ本体のシグニチャ
  */
 [context("non-task")]
@@ -486,5 +468,5 @@
 
 /*
- *  ã¿ã¤ã ã¤ãã³ããã³ãã©ãæå®ããããã®ã»ã«ã¿ã¤ã
+ *  タイムイベントハンドラを指定するためのセルタイプ
  */
 celltype tTimeEventHandler {
@@ -498,5 +480,5 @@
 
 /*
- *  å¨æéç¥ãæä½ããããã®ã·ã°ããã£ï¼ã¿ã¹ã¯ã³ã³ãã­ã¹ãç¨ï¼
+ *  周期通知を操作するためのシグニチャ（タスクコンテキスト用）
  */
 signature sCyclic {
@@ -507,5 +489,5 @@
 
 /*
- *  å¨æéç¥ã®ã»ã«ã¿ã¤ã
+ *  周期通知のセルタイプ
  */
 [active, generate(NotifierPlugin,
@@ -525,24 +507,24 @@
 		[omit] RELTIM	cyclePhase = 0;
 
-		/* å¤æ°ã®è¨­å®ã«ããéç¥ï¼TNFY_SETVARï¼*/
+		/* 変数の設定による通知（TNFY_SETVAR）*/
 		[omit] intptr_t *setVariableAddress = 0;
 		[omit] intptr_t setVariableValue = 0;
 
-		/* å¤æ°ã®ã¤ã³ã¯ãªã¡ã³ãã«ããéç¥ï¼TNFY_INCVARï¼*/
+		/* 変数のインクリメントによる通知（TNFY_INCVAR）*/
 		[omit] intptr_t *incrementedVariableAddress = 0;
 
-		/* ã¤ãã³ããã©ã°ã®ã»ããã«ããéç¥ï¼TNFY_SETFLGï¼*/
+		/* イベントフラグのセットによる通知（TNFY_SETFLG）*/
 		[omit] FLGPTN flagPattern = 0;
 
-		/* ãã¼ã¿ã­ã¥ã¼ã¸ã®éä¿¡ã«ããéç¥ï¼TNFY_SNDDTQï¼*/
+		/* データキューへの送信による通知（TNFY_SNDDTQ）*/
 		[omit] intptr_t dataqueueSentValue = 0;
 
-		/* å¤æ°ã®è¨­å®ã«ããã¨ã©ã¼éç¥ï¼TENFY_SETVARï¼*/
+		/* 変数の設定によるエラー通知（TENFY_SETVAR）*/
 		[omit] intptr_t *setVariableAddressForError = 0;
 
-		/* å¤æ°ã®ã¤ã³ã¯ãªã¡ã³ãã«ããã¨ã©ã¼éç¥ï¼TENFY_INCVARï¼*/
+		/* 変数のインクリメントによるエラー通知（TENFY_INCVAR）*/
 		[omit] intptr_t *incrementedVariableAddressForError = 0;
 
-		/* ã¤ãã³ããã©ã°ã®ã»ããã«ããã¨ã©ã¼éç¥ï¼TENFY_SETFLGï¼*/
+		/* イベントフラグのセットによるエラー通知（TENFY_SETFLG）*/
 		[omit] FLGPTN flagPatternForError = 0;
 	};
@@ -554,5 +536,5 @@
 
 /*
- *  å¨æéç¥ã«ã¦ã¼ã¶ã¼ãã³ãã©ãæå®ããããã®è¤åã»ã«ã¿ã¤ã
+ *  周期通知にユーザーハンドラを指定するための複合セルタイプ
  */
 [active]
@@ -584,5 +566,5 @@
 
 /*
- *  ã¢ã©ã¼ã éç¥ãæä½ããããã®ã·ã°ããã£ï¼ã¿ã¹ã¯ã³ã³ãã­ã¹ãç¨ï¼
+ *  アラーム通知を操作するためのシグニチャ（タスクコンテキスト用）
  */
 signature sAlarm {
@@ -593,5 +575,5 @@
 
 /*
- *  ã¢ã©ã¼ã éç¥ãæä½ããããã®ã·ã°ããã£ï¼éã¿ã¹ã¯ã³ã³ãã­ã¹ãç¨ï¼
+ *  アラーム通知を操作するためのシグニチャ（非タスクコンテキスト用）
  */
 [context("non-task")]
@@ -602,5 +584,5 @@
 
 /*
- *  ã¢ã©ã¼ã éç¥ã®ã»ã«ã¿ã¤ã
+ *  アラーム通知のセルタイプ
  */
 [active, generate(NotifierPlugin,
@@ -619,24 +601,24 @@
 		[omit] bool_t	ignoreErrors = false;
 
-		/* å¤æ°ã®è¨­å®ã«ããéç¥ï¼TNFY_SETVARï¼*/
+		/* 変数の設定による通知（TNFY_SETVAR）*/
 		[omit] intptr_t *setVariableAddress = 0;
 		[omit] intptr_t setVariableValue = 0;
 
-		/* å¤æ°ã®ã¤ã³ã¯ãªã¡ã³ãã«ããéç¥ï¼TNFY_INCVARï¼*/
+		/* 変数のインクリメントによる通知（TNFY_INCVAR）*/
 		[omit] intptr_t *incrementedVariableAddress = 0;
 
-		/* ã¤ãã³ããã©ã°ã®ã»ããã«ããéç¥ï¼TNFY_SETFLGï¼*/
+		/* イベントフラグのセットによる通知（TNFY_SETFLG）*/
 		[omit] FLGPTN flagPattern = 0;
 
-		/* ãã¼ã¿ã­ã¥ã¼ã¸ã®éä¿¡ã«ããéç¥ï¼TNFY_SNDDTQï¼*/
+		/* データキューへの送信による通知（TNFY_SNDDTQ）*/
 		[omit] intptr_t dataqueueSentValue = 0;
 
-		/* å¤æ°ã®è¨­å®ã«ããã¨ã©ã¼éç¥ï¼TENFY_SETVARï¼*/
+		/* 変数の設定によるエラー通知（TENFY_SETVAR）*/
 		[omit] intptr_t *setVariableAddressForError = 0;
 
-		/* å¤æ°ã®ã¤ã³ã¯ãªã¡ã³ãã«ããã¨ã©ã¼éç¥ï¼TENFY_INCVARï¼*/
+		/* 変数のインクリメントによるエラー通知（TENFY_INCVAR）*/
 		[omit] intptr_t *incrementedVariableAddressForError = 0;
 
-		/* ã¤ãã³ããã©ã°ã®ã»ããã«ããã¨ã©ã¼éç¥ï¼TENFY_SETFLGï¼*/
+		/* イベントフラグのセットによるエラー通知（TENFY_SETFLG）*/
 		[omit] FLGPTN flagPatternForError = 0;
 	};
@@ -648,5 +630,5 @@
 
 /*
- *  ã¢ã©ã¼ã éç¥ã«ã¦ã¼ã¶ã¼ãã³ãã©ãæå®ããããã®è¤åã»ã«ã¿ã¤ã
+ *  アラーム通知にユーザーハンドラを指定するための複合セルタイプ
  */
 [active]
@@ -676,5 +658,5 @@
 
 /*
- *  å²è¾¼ã¿è¦æ±ã©ã¤ã³æä½ã®ã·ã°ããã£ï¼ã¿ã¹ã¯ã³ã³ãã­ã¹ãç¨ï¼
+ *  割込み要求ライン操作のシグニチャ（タスクコンテキスト用）
  */
 signature sInterruptRequest {
@@ -687,5 +669,5 @@
 
 /*
- *  å²è¾¼ã¿è¦æ±ã©ã¤ã³ã®ã»ã«ã¿ã¤ã
+ *  割込み要求ラインのセルタイプ
  */
 celltype tInterruptRequest {
@@ -705,5 +687,5 @@
 
 /*
- *  å²è¾¼ã¿ãµã¼ãã¹ã«ã¼ãã³ã®ã»ã«ã¿ã¤ã
+ *  割込みサービスルーチンのセルタイプ
  */
 [active]
@@ -729,5 +711,5 @@
 
 /*
- *  å²è¾¼ã¿ãã³ãã©ã®ã»ã«ã¿ã¤ã
+ *  割込みハンドラのセルタイプ
  */
 [active]
@@ -750,5 +732,5 @@
 
 /*
- *  CPUä¾å¤ãã³ãã©ã®ã»ã«ã¿ã¤ã
+ *  CPU例外ハンドラのセルタイプ
  */
 [active]
@@ -771,5 +753,5 @@
 
 /*
- *  åæåï¼çµäºå¦çã«ã¼ãã³æ¬ä½ã®ã·ã°ããã£
+ *  初期化／終了処理ルーチン本体のシグニチャ
  */
 signature sRoutineBody {
@@ -778,5 +760,5 @@
 
 /*
- *  åæåã«ã¼ãã³ã®ã»ã«ã¿ã¤ã
+ *  初期化ルーチンのセルタイプ
  */
 [active]
@@ -799,5 +781,5 @@
 
 /*
- *  çµäºå¦çã«ã¼ãã³ã®ã»ã«ã¿ã¤ã
+ *  終了処理ルーチンのセルタイプ
  */
 [active]