Index: /asp3_gr_sakura/trunk/arch/rx630_gcc/prc_kernel.trb
===================================================================
--- /asp3_gr_sakura/trunk/arch/rx630_gcc/prc_kernel.trb	(revision 332)
+++ /asp3_gr_sakura/trunk/arch/rx630_gcc/prc_kernel.trb	(revision 333)
@@ -325,17 +325,17 @@
   if $INTNO_INT.include?(key)
     # TA_POSEDGEとTA_NEGEDGEが同時に設定されている場合
-    if (params[:intatr].val & $TA_POSEDGE|$TA_NEGEDGE) == $TA_POSEDGE|$TA_NEGEDGE
+    if (params[:intatr].val & ($TA_POSEDGE|$TA_NEGEDGE)) == $TA_POSEDGE|$TA_NEGEDGE
       error_illegal_sym("E_RSATR", params, :intatr, :intno)
     end
     # TA_POSEDGEとTA_BOTHEDGEが同時に設定されている場合
-    if (params[:intatr].val & $TA_POSEDGE|$TA_BOTHEDGE) == $TA_POSEDGE|$TA_BOTHEDGE
+    if (params[:intatr].val & ($TA_POSEDGE|$TA_BOTHEDGE)) == $TA_POSEDGE|$TA_BOTHEDGE
       error_illegal_sym("E_RSATR", params, :intatr, :intno)
     end
     # TA_NEGEDGEとTA_BOTHEDGEが同時に設定されている場合
-    if (params[:intatr].val & $TA_NEGEDGE|$TA_BOTHEDGE) == $TA_NEGEDGE|$TA_BOTHEDGE
+    if (params[:intatr].val & ($TA_NEGEDGE|$TA_BOTHEDGE)) == $TA_NEGEDGE|$TA_BOTHEDGE
       error_illegal_sym("E_RSATR", params, :intatr, :intno)
     end
     # TA_POSEDGEとTA_NEGEDGEとTA_BOTHEDGEが同時に設定されている場合
-    if (params[:intatr].val & $TA_POSEDGE|$TA_NEGEDGE|$TA_BOTHEDGE) == $TA_POSEDGE|$TA_NEGEDGE|$TA_BOTHEDGE
+    if (params[:intatr].val & ($TA_POSEDGE|$TA_NEGEDGE|$TA_BOTHEDGE)) == $TA_POSEDGE|$TA_NEGEDGE|$TA_BOTHEDGE
       error_illegal_sym("E_RSATR", params, :intatr, :intno)
     end
Index: /rubycfg_asp/trunk/asp_dcre/arch/rx630_ccrx/prc_kernel.trb
===================================================================
--- /rubycfg_asp/trunk/asp_dcre/arch/rx630_ccrx/prc_kernel.trb	(revision 332)
+++ /rubycfg_asp/trunk/asp_dcre/arch/rx630_ccrx/prc_kernel.trb	(revision 333)
@@ -329,17 +329,17 @@
   if $INTNO_INT.include?(key)
     # TA_POSEDGEとTA_NEGEDGEが同時に設定されている場合
-    if (params[:intatr].val & $TA_POSEDGE|$TA_NEGEDGE) == $TA_POSEDGE|$TA_NEGEDGE
+    if (params[:intatr].val & ($TA_POSEDGE|$TA_NEGEDGE)) == $TA_POSEDGE|$TA_NEGEDGE
       error_illegal_sym("E_RSATR", params, :intatr, :intno)
     end
     # TA_POSEDGEとTA_BOTHEDGEが同時に設定されている場合
-    if (params[:intatr].val & $TA_POSEDGE|$TA_BOTHEDGE) == $TA_POSEDGE|$TA_BOTHEDGE
+    if (params[:intatr].val & ($TA_POSEDGE|$TA_BOTHEDGE)) == $TA_POSEDGE|$TA_BOTHEDGE
       error_illegal_sym("E_RSATR", params, :intatr, :intno)
     end
     # TA_NEGEDGEとTA_BOTHEDGEが同時に設定されている場合
-    if (params[:intatr].val & $TA_NEGEDGE|$TA_BOTHEDGE) == $TA_NEGEDGE|$TA_BOTHEDGE
+    if (params[:intatr].val & ($TA_NEGEDGE|$TA_BOTHEDGE)) == $TA_NEGEDGE|$TA_BOTHEDGE
       error_illegal_sym("E_RSATR", params, :intatr, :intno)
     end
     # TA_POSEDGEとTA_NEGEDGEとTA_BOTHEDGEが同時に設定されている場合
-    if (params[:intatr].val & $TA_POSEDGE|$TA_NEGEDGE|$TA_BOTHEDGE) == $TA_POSEDGE|$TA_NEGEDGE|$TA_BOTHEDGE
+    if (params[:intatr].val & ($TA_POSEDGE|$TA_NEGEDGE|$TA_BOTHEDGE)) == $TA_POSEDGE|$TA_NEGEDGE|$TA_BOTHEDGE
       error_illegal_sym("E_RSATR", params, :intatr, :intno)
     end
Index: /rubycfg_asp/trunk/asp_dcre/arch/rx630_gcc/prc_kernel.trb
===================================================================
--- /rubycfg_asp/trunk/asp_dcre/arch/rx630_gcc/prc_kernel.trb	(revision 332)
+++ /rubycfg_asp/trunk/asp_dcre/arch/rx630_gcc/prc_kernel.trb	(revision 333)
@@ -325,17 +325,17 @@
   if $INTNO_INT.include?(key)
     # TA_POSEDGEとTA_NEGEDGEが同時に設定されている場合
-    if (params[:intatr].val & $TA_POSEDGE|$TA_NEGEDGE) == $TA_POSEDGE|$TA_NEGEDGE
+    if (params[:intatr].val & ($TA_POSEDGE|$TA_NEGEDGE)) == $TA_POSEDGE|$TA_NEGEDGE
       error_illegal_sym("E_RSATR", params, :intatr, :intno)
     end
     # TA_POSEDGEとTA_BOTHEDGEが同時に設定されている場合
-    if (params[:intatr].val & $TA_POSEDGE|$TA_BOTHEDGE) == $TA_POSEDGE|$TA_BOTHEDGE
+    if (params[:intatr].val & ($TA_POSEDGE|$TA_BOTHEDGE)) == $TA_POSEDGE|$TA_BOTHEDGE
       error_illegal_sym("E_RSATR", params, :intatr, :intno)
     end
     # TA_NEGEDGEとTA_BOTHEDGEが同時に設定されている場合
-    if (params[:intatr].val & $TA_NEGEDGE|$TA_BOTHEDGE) == $TA_NEGEDGE|$TA_BOTHEDGE
+    if (params[:intatr].val & ($TA_NEGEDGE|$TA_BOTHEDGE)) == $TA_NEGEDGE|$TA_BOTHEDGE
       error_illegal_sym("E_RSATR", params, :intatr, :intno)
     end
     # TA_POSEDGEとTA_NEGEDGEとTA_BOTHEDGEが同時に設定されている場合
-    if (params[:intatr].val & $TA_POSEDGE|$TA_NEGEDGE|$TA_BOTHEDGE) == $TA_POSEDGE|$TA_NEGEDGE|$TA_BOTHEDGE
+    if (params[:intatr].val & ($TA_POSEDGE|$TA_NEGEDGE|$TA_BOTHEDGE)) == $TA_POSEDGE|$TA_NEGEDGE|$TA_BOTHEDGE
       error_illegal_sym("E_RSATR", params, :intatr, :intno)
     end