Index: /asp3_tinet_ecnl_rx/trunk/app2_light/src/main.c
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app2_light/src/main.c	(revision 340)
+++ /asp3_tinet_ecnl_rx/trunk/app2_light/src/main.c	(revision 341)
@@ -313,4 +313,5 @@
 extern int usrcmd_dhcp4c(int argc, char **argv);
 extern int usrcmd_dnsc(int argc, char **argv);
+extern int usrcmd_ntpc(int argc, char **argv);
 
 static const cmd_table_t cmdlist[] = {
@@ -326,4 +327,5 @@
 	{"dhcpc", "DHCP Client rel/renew/info", usrcmd_dhcp4c},
 	{"dnsc", "DNS client", usrcmd_dnsc },
+	{"ntpc", "NTP client", usrcmd_ntpc },
 	{"info", "This is a description text string for info command.", usrcmd_info},
 	{"exit", "Exit Natural Tiny Shell", usrcmd_exit},
Index: /asp3_tinet_ecnl_rx/trunk/app3_human_detec/src/main.c
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app3_human_detec/src/main.c	(revision 340)
+++ /asp3_tinet_ecnl_rx/trunk/app3_human_detec/src/main.c	(revision 341)
@@ -313,4 +313,5 @@
 extern int usrcmd_dhcp4c(int argc, char **argv);
 extern int usrcmd_dnsc(int argc, char **argv);
+extern int usrcmd_ntpc(int argc, char **argv);
 
 static const cmd_table_t cmdlist[] = {
@@ -326,4 +327,5 @@
 	{"dhcpc", "DHCP Client rel/renew/info", usrcmd_dhcp4c},
 	{"dnsc", "DNS client", usrcmd_dnsc },
+	{"ntpc", "NTP client", usrcmd_ntpc },
 	{"info", "This is a description text string for info command.", usrcmd_info},
 	{"exit", "Exit Natural Tiny Shell", usrcmd_exit},
Index: /asp3_tinet_ecnl_rx/trunk/app4_aircon/src/main.c
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app4_aircon/src/main.c	(revision 340)
+++ /asp3_tinet_ecnl_rx/trunk/app4_aircon/src/main.c	(revision 341)
@@ -313,4 +313,5 @@
 extern int usrcmd_dhcp4c(int argc, char **argv);
 extern int usrcmd_dnsc(int argc, char **argv);
+extern int usrcmd_ntpc(int argc, char **argv);
 
 static const cmd_table_t cmdlist[] = {
@@ -326,4 +327,5 @@
 	{"dhcpc", "DHCP Client rel/renew/info", usrcmd_dhcp4c},
 	{"dnsc", "DNS client", usrcmd_dnsc },
+	{"ntpc", "NTP client", usrcmd_ntpc },
 	{"info", "This is a description text string for info command.", usrcmd_info},
 	{"exit", "Exit Natural Tiny Shell", usrcmd_exit},
Index: /asp3_tinet_ecnl_rx/trunk/app5_temp_sensor/src/main.c
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app5_temp_sensor/src/main.c	(revision 340)
+++ /asp3_tinet_ecnl_rx/trunk/app5_temp_sensor/src/main.c	(revision 341)
@@ -313,4 +313,5 @@
 extern int usrcmd_dhcp4c(int argc, char **argv);
 extern int usrcmd_dnsc(int argc, char **argv);
+extern int usrcmd_ntpc(int argc, char **argv);
 
 static const cmd_table_t cmdlist[] = {
@@ -326,4 +327,5 @@
 	{"dhcpc", "DHCP Client rel/renew/info", usrcmd_dhcp4c},
 	{"dnsc", "DNS client", usrcmd_dnsc },
+	{"ntpc", "NTP client", usrcmd_ntpc },
 	{"info", "This is a description text string for info command.", usrcmd_info},
 	{"exit", "Exit Natural Tiny Shell", usrcmd_exit},
Index: /asp3_tinet_ecnl_rx/trunk/app6_hot_water_pot/src/main.c
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app6_hot_water_pot/src/main.c	(revision 340)
+++ /asp3_tinet_ecnl_rx/trunk/app6_hot_water_pot/src/main.c	(revision 341)
@@ -313,4 +313,5 @@
 extern int usrcmd_dhcp4c(int argc, char **argv);
 extern int usrcmd_dnsc(int argc, char **argv);
+extern int usrcmd_ntpc(int argc, char **argv);
 
 static const cmd_table_t cmdlist[] = {
@@ -326,4 +327,5 @@
 	{"dhcpc", "DHCP Client rel/renew/info", usrcmd_dhcp4c},
 	{"dnsc", "DNS client", usrcmd_dnsc },
+	{"ntpc", "NTP client", usrcmd_ntpc },
 	{"info", "This is a description text string for info command.", usrcmd_info},
 	{"exit", "Exit Natural Tiny Shell", usrcmd_exit},
Index: /asp3_tinet_ecnl_rx/trunk/app7_buzzer/src/main.c
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app7_buzzer/src/main.c	(revision 340)
+++ /asp3_tinet_ecnl_rx/trunk/app7_buzzer/src/main.c	(revision 341)
@@ -313,4 +313,5 @@
 extern int usrcmd_dhcp4c(int argc, char **argv);
 extern int usrcmd_dnsc(int argc, char **argv);
+extern int usrcmd_ntpc(int argc, char **argv);
 
 static const cmd_table_t cmdlist[] = {
@@ -326,4 +327,5 @@
 	{"dhcpc", "DHCP Client rel/renew/info", usrcmd_dhcp4c},
 	{"dnsc", "DNS client", usrcmd_dnsc },
+	{"ntpc", "NTP client", usrcmd_ntpc },
 	{"info", "This is a description text string for info command.", usrcmd_info},
 	{"exit", "Exit Natural Tiny Shell", usrcmd_exit},
Index: /asp3_tinet_ecnl_rx/trunk/bnep_bridge/src/main.c
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/bnep_bridge/src/main.c	(revision 340)
+++ /asp3_tinet_ecnl_rx/trunk/bnep_bridge/src/main.c	(revision 341)
@@ -284,4 +284,5 @@
 	{"mkdir", "Make directory", usrcmd_mkdir},
 	{"hexdump", "Hex dump", usrcmd_hexdump},
+	{"date", "print date and time", usrcmd_date},
 	{"info", "This is a description text string for info command.", usrcmd_info},
 	{"exit", "Exit Natural Tiny Shell", usrcmd_exit},