Index: asp3_tinet_ecnl_rx/trunk/asp3_dcre/Debug/Makefile
===================================================================
--- asp3_tinet_ecnl_rx/trunk/asp3_dcre/Debug/Makefile	(revision 340)
+++ asp3_tinet_ecnl_rx/trunk/asp3_dcre/Debug/Makefile	(revision 342)
@@ -369,5 +369,5 @@
 tecs $(TECSGEN_SRCS) $(TECS_HEADERS): $(TECSGEN_TIMESTAMP) ;
 $(TECSGEN_TIMESTAMP): $(APPL_CDL) $(TECS_IMPORTS)
-	$(TECSGEN) $< -R $(INCLUDES) --cpp "$(TECS_CPP)" -g $(TECSGENDIR)
+	$(TECSGEN) $< -R $(INCLUDES) --cpp "$(subst ", \", $(TECS_CPP))" -g $(TECSGENDIR)
 
 #
Index: asp3_tinet_ecnl_rx/trunk/asp3_dcre/DebugCitrus/Makefile
===================================================================
--- asp3_tinet_ecnl_rx/trunk/asp3_dcre/DebugCitrus/Makefile	(revision 340)
+++ asp3_tinet_ecnl_rx/trunk/asp3_dcre/DebugCitrus/Makefile	(revision 342)
@@ -369,5 +369,5 @@
 tecs $(TECSGEN_SRCS) $(TECS_HEADERS): $(TECSGEN_TIMESTAMP) ;
 $(TECSGEN_TIMESTAMP): $(APPL_CDL) $(TECS_IMPORTS)
-	$(TECSGEN) $< -R $(INCLUDES) --cpp "$(TECS_CPP)" -g $(TECSGENDIR)
+	$(TECSGEN) $< -R $(INCLUDES) --cpp "$(subst ", \", $(TECS_CPP))" -g $(TECSGENDIR)
 
 #
Index: asp3_tinet_ecnl_rx/trunk/asp3_dcre/arch/rx630_gcc/prc_kernel_impl.c
===================================================================
--- asp3_tinet_ecnl_rx/trunk/asp3_dcre/arch/rx630_gcc/prc_kernel_impl.c	(revision 340)
+++ asp3_tinet_ecnl_rx/trunk/asp3_dcre/arch/rx630_gcc/prc_kernel_impl.c	(revision 342)
@@ -39,5 +39,5 @@
  *  の責任を負わない．
  * 
- *  @(#) $Id$
+ *  @(#) $Id: prc_kernel_impl.c 1518 2018-04-24 00:37:16Z coas-nagasima $
  */
 
@@ -237,2 +237,55 @@
 #endif /* OMIT_DEFAULT_EXC_HANDLER */
 
+void _start_c(char **args);
+
+void
+_sta_ker()
+{
+	const char *const args[] = {
+		1,
+		"asp3",
+		0,
+		"TZ=JST-9",
+		0
+	};
+	_start_c(args);
+}
+
+//#include <errno.h>
+#define ENOSYS          38
+
+__attribute__((weak))
+long SYS_poll()
+{
+	return -ENOSYS;
+}
+
+__attribute__((weak))
+long SYS_open()
+{
+	return -ENOSYS;
+}
+
+__attribute__((weak))
+void SYS_set_tid_address()
+{
+	return 0;//-ENOSYS;
+}
+
+__attribute__((weak))
+void SYS_mmap2()
+{
+	return 0;//-ENOSYS;
+}
+
+__attribute__((weak))
+void SYS_exit_group()
+{
+	ext_ker();
+}
+
+__attribute__((weak))
+void SYS_exit()
+{
+	ext_ker();
+}
Index: asp3_tinet_ecnl_rx/trunk/asp3_dcre/arch/rx630_gcc/start.S
===================================================================
--- asp3_tinet_ecnl_rx/trunk/asp3_dcre/arch/rx630_gcc/start.S	(revision 340)
+++ asp3_tinet_ecnl_rx/trunk/asp3_dcre/arch/rx630_gcc/start.S	(revision 342)
@@ -144,5 +144,5 @@
 	;
 kernel_link:
-	bra.a	_sta_ker					; --> _sta_ker()
+	bra.a	__sta_ker					; --> __sta_ker()
 
 	.end
Index: asp3_tinet_ecnl_rx/trunk/asp3_dcre/include/t_syslog.h
===================================================================
--- asp3_tinet_ecnl_rx/trunk/asp3_dcre/include/t_syslog.h	(revision 340)
+++ asp3_tinet_ecnl_rx/trunk/asp3_dcre/include/t_syslog.h	(revision 342)
@@ -140,7 +140,4 @@
 
 #ifndef TOPPERS_OMIT_SYSLOG
-#ifdef TOPPERS_OMIT_TECS
-#define tSysLog_eSysLog_write syslog_wri_log
-#endif
 
 /*
Index: asp3_tinet_ecnl_rx/trunk/asp3_dcre/sample/Makefile
===================================================================
--- asp3_tinet_ecnl_rx/trunk/asp3_dcre/sample/Makefile	(revision 340)
+++ asp3_tinet_ecnl_rx/trunk/asp3_dcre/sample/Makefile	(revision 342)
@@ -362,5 +362,5 @@
 tecs $(TECSGEN_SRCS) $(TECS_HEADERS): $(TECSGEN_TIMESTAMP) ;
 $(TECSGEN_TIMESTAMP): $(APPL_CDL) $(TECS_IMPORTS)
-	$(TECSGEN) $< -R $(INCLUDES) --cpp "$(TECS_CPP)" -g $(TECSGENDIR)
+	$(TECSGEN) $< -R $(INCLUDES) --cpp "$(subst ", \", $(TECS_CPP))" -g $(TECSGENDIR)
 
 #
Index: asp3_tinet_ecnl_rx/trunk/asp3_dcre/syssvc/tSerialPortMain.c
===================================================================
--- asp3_tinet_ecnl_rx/trunk/asp3_dcre/syssvc/tSerialPortMain.c	(revision 340)
+++ asp3_tinet_ecnl_rx/trunk/asp3_dcre/syssvc/tSerialPortMain.c	(revision 342)
@@ -504,4 +504,5 @@
 	pk_rpor->reacnt = VAR_receiveCount;
 	pk_rpor->wricnt = VAR_sendCount;
+	pk_rpor->wbufsz = ATTR_sendBufferSize;
 	return(E_OK);
 }
Index: asp3_tinet_ecnl_rx/trunk/asp3_dcre/tinet/net/ethernet.c
===================================================================
--- asp3_tinet_ecnl_rx/trunk/asp3_dcre/tinet/net/ethernet.c	(revision 340)
+++ asp3_tinet_ecnl_rx/trunk/asp3_dcre/tinet/net/ethernet.c	(revision 342)
@@ -29,5 +29,5 @@
  *  接的または間接的に生じたいかなる損害に関しても，その責任を負わない．
  * 
- *  @(#) $Id$
+ *  @(#) $Id: ethernet.c 1524 2018-04-25 13:48:23Z coas-nagasima $
  */
 
@@ -195,72 +195,83 @@
 
 /**
- * Called by a driver when its link goes up
- */
-void ether_set_link_up()
-{
-  if (!(ether_ifnet.flags & IF_FLAG_LINK_UP)) {
-    ether_ifnet.flags |= IF_FLAG_LINK_UP;
-
-    if (ether_ifnet.flags & IF_FLAG_UP) {
-#if LWIP_ARP
-      /* For Ethernet network interfaces, we would like to send a "gratuitous ARP" */ 
-      if (ether_ifnet.flags & IF_FLAG_ETHARP) {
-        etharp_gratuitous(&ether_ifnet);
-      }
-#endif /* LWIP_ARP */
-
-#if LWIP_IGMP
-      /* resend IGMP memberships */
-      if (ether_ifnet._flags & IF_FLAG_IGMP) {
-        igmp_report_groups(&ether_ifnet);
-      }
-#endif /* LWIP_IGMP */
-    }
-    if (ether_ifnet.link_callback) {
-      (ether_ifnet.link_callback)(&ether_ifnet);
-    }
-  }
-}
+ * ether_set_link_up -- リンクしたときにNICから呼び出される
+ */
+void
+ether_set_link_up()
+{
+	if (!(ether_ifnet.flags & IF_FLAG_LINK_UP)) {
+		ether_ifnet.flags |= IF_FLAG_LINK_UP;
+
+		if (ether_ifnet.flags & IF_FLAG_UP) {
+#if defined(_IP4_CFG) && defined(SUPPORT_ETHER)
+			/* ARP再構築？ */
+#endif /* #if defined(_IP4_CFG) && defined(SUPPORT_ETHER) */
+
+#ifdef SUPPORT_IGMP
+			/* IGMP参加 */
+#endif /* #ifdef SUPPORT_IGMP */
+			}
+		if (ether_ifnet.link_callback) {
+			(ether_ifnet.link_callback)(&ether_ifnet);
+			}
+		}
+	}
 
 /**
- * Called by a driver when its link goes down
- */
-void ether_set_link_down()
-{
-  if (ether_ifnet.flags & IF_FLAG_LINK_UP) {
-    ether_ifnet.flags &= ~IF_FLAG_LINK_UP;
-    if (ether_ifnet.link_callback) {
-      (ether_ifnet.link_callback)(&ether_ifnet);
-    }
-  }
-}
-
-void ether_set_up()
-{
-  if (!(ether_ifnet.flags & IF_FLAG_UP)) {
-    ether_ifnet.flags |= IF_FLAG_UP;
-    if (ether_ifnet.link_callback) {
-      (ether_ifnet.link_callback)(&ether_ifnet);
-    }
-  }
-}
-
-void ether_set_down()
-{
-  if (ether_ifnet.flags & IF_FLAG_UP) {
-    ether_ifnet.flags &= ~IF_FLAG_UP;
-    if (ether_ifnet.link_callback) {
-      (ether_ifnet.link_callback)(&ether_ifnet);
-    }
-  }
-}
-
-/**
- * Set callback to be called when link is brought up/down
- */
-void ether_set_link_callback(ether_status_callback_fn link_callback)
+ * ether_set_link_up -- リンクが切断したときにNICから呼び出される
+ */
+void
+ether_set_link_down()
+{
+	if (ether_ifnet.flags & IF_FLAG_LINK_UP) {
+		ether_ifnet.flags &= ~IF_FLAG_LINK_UP;
+		if (ether_ifnet.link_callback) {
+			(ether_ifnet.link_callback)(&ether_ifnet);
+			}
+		}
+	}
+
+/*
+ * ether_set_up -- DHCPでアドレスが設定されたとき呼び出される
+ */
+
+void
+ether_set_up()
+{
+	if (!(ether_ifnet.flags & IF_FLAG_UP)) {
+		ether_ifnet.flags |= IF_FLAG_UP;
+		if (ether_ifnet.link_callback) {
+			(ether_ifnet.link_callback)(&ether_ifnet);
+			}
+		}
+	}
+
+/*
+ * ether_set_down -- DHCPでアドレスが解放されたとき呼び出される
+ */
+
+void
+ether_set_down()
+{
+	if (ether_ifnet.flags & IF_FLAG_UP) {
+		ether_ifnet.flags &= ~IF_FLAG_UP;
+		if (ether_ifnet.link_callback) {
+			(ether_ifnet.link_callback)(&ether_ifnet);
+			}
+		}
+	}
+
+/*
+ * ether_set_link_callback -- リンク状態変化時のコールバック登録
+ */
+
+void
+ether_set_link_callback(ether_status_callback_fn link_callback)
 {
 	ether_ifnet.link_callback = link_callback;
-}
+	if (ether_ifnet.link_callback) {
+		(ether_ifnet.link_callback)(&ether_ifnet);
+		}
+	}
 
 /*
Index: asp3_tinet_ecnl_rx/trunk/asp3_dcre/tinet/net/ethernet.h
===================================================================
--- asp3_tinet_ecnl_rx/trunk/asp3_dcre/tinet/net/ethernet.h	(revision 340)
+++ asp3_tinet_ecnl_rx/trunk/asp3_dcre/tinet/net/ethernet.h	(revision 342)
@@ -29,5 +29,5 @@
  *  接的または間接的に生じたいかなる損害に関しても，その責任を負わない．
  * 
- *  @(#) $Id$
+ *  @(#) $Id: ethernet.h 1524 2018-04-25 13:48:23Z coas-nagasima $
  */
 
@@ -311,5 +311,4 @@
 extern uint32_t ether_srand (void);
 
-/** Function prototype for netif status- or link-callback functions. */
 typedef void (*ether_status_callback_fn)(T_IFNET *ether);
 extern void ether_set_link_callback(ether_status_callback_fn link_callback);
Index: asp3_tinet_ecnl_rx/trunk/asp3_dcre/tinet/netapp/dhcp4_cli_var.h
===================================================================
--- asp3_tinet_ecnl_rx/trunk/asp3_dcre/tinet/netapp/dhcp4_cli_var.h	(revision 340)
+++ asp3_tinet_ecnl_rx/trunk/asp3_dcre/tinet/netapp/dhcp4_cli_var.h	(revision 342)
@@ -165,5 +165,5 @@
 	ER_UINT		error;		/* エラー・データ長		*/
 	ID			tskid;		/* タスクID */
-	ID		cepid;		/* CEP ID			*/
+	ID			cepid;		/* CEP ID			*/
 	uint32_t	xid;		/* トランザクション ID		*/
 	uint16_t	flags;		/* 各種フラグ			*/