Index: /asp3_tinet_ecnl_rx/trunk/app1_usb_watt_meter/src/main.c
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app1_usb_watt_meter/src/main.c	(revision 348)
+++ /asp3_tinet_ecnl_rx/trunk/app1_usb_watt_meter/src/main.c	(revision 349)
@@ -85,11 +85,4 @@
 extern int bt_bnep_mode;
 /* PANU向けリモートアドレス */
-// BUFFALLO
-//bd_addr_t remote_addr = { 0x00,0x1B,0xDC,0x04,0x5C,0x2D };
-// Raspberry Pi 3
-//bd_addr_t remote_addr = {0xB8,0x27,0xEB,0x10,0x6D,0x60};
-// PRINCETON
-//bd_addr_t remote_addr = {0x00,0x1B,0xDC,0x06,0x6E,0x98};
-// ELECOM
 bd_addr_t remote_addr = {0x00,0x1B,0xDC,0x09,0x27,0x26};
 #endif
Index: /asp3_tinet_ecnl_rx/trunk/app2_light/src/main.c
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app2_light/src/main.c	(revision 348)
+++ /asp3_tinet_ecnl_rx/trunk/app2_light/src/main.c	(revision 349)
@@ -84,11 +84,4 @@
 extern int bt_bnep_mode;
 /* PANU向けリモートアドレス */
-// BUFFALLO
-//bd_addr_t remote_addr = { 0x00,0x1B,0xDC,0x04,0x5C,0x2D };
-// Raspberry Pi 3
-//bd_addr_t remote_addr = {0xB8,0x27,0xEB,0x10,0x6D,0x60};
-// PRINCETON
-//bd_addr_t remote_addr = {0x00,0x1B,0xDC,0x06,0x6E,0x98};
-// ELECOM
 bd_addr_t remote_addr = {0x00,0x1B,0xDC,0x09,0x27,0x26};
 #endif
Index: /asp3_tinet_ecnl_rx/trunk/app3_human_detec/src/main.c
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app3_human_detec/src/main.c	(revision 348)
+++ /asp3_tinet_ecnl_rx/trunk/app3_human_detec/src/main.c	(revision 349)
@@ -84,11 +84,4 @@
 extern int bt_bnep_mode;
 /* PANU向けリモートアドレス */
-// BUFFALLO
-//bd_addr_t remote_addr = { 0x00,0x1B,0xDC,0x04,0x5C,0x2D };
-// Raspberry Pi 3
-//bd_addr_t remote_addr = {0xB8,0x27,0xEB,0x10,0x6D,0x60};
-// PRINCETON
-//bd_addr_t remote_addr = {0x00,0x1B,0xDC,0x06,0x6E,0x98};
-// ELECOM
 bd_addr_t remote_addr = {0x00,0x1B,0xDC,0x09,0x27,0x26};
 #endif
Index: /asp3_tinet_ecnl_rx/trunk/app4_aircon/src/main.c
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app4_aircon/src/main.c	(revision 348)
+++ /asp3_tinet_ecnl_rx/trunk/app4_aircon/src/main.c	(revision 349)
@@ -84,11 +84,4 @@
 extern int bt_bnep_mode;
 /* PANU向けリモートアドレス */
-// BUFFALLO
-//bd_addr_t remote_addr = { 0x00,0x1B,0xDC,0x04,0x5C,0x2D };
-// Raspberry Pi 3
-//bd_addr_t remote_addr = {0xB8,0x27,0xEB,0x10,0x6D,0x60};
-// PRINCETON
-//bd_addr_t remote_addr = {0x00,0x1B,0xDC,0x06,0x6E,0x98};
-// ELECOM
 bd_addr_t remote_addr = {0x00,0x1B,0xDC,0x09,0x27,0x26};
 #endif
Index: /asp3_tinet_ecnl_rx/trunk/app5_temp_sensor/src/main.c
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app5_temp_sensor/src/main.c	(revision 348)
+++ /asp3_tinet_ecnl_rx/trunk/app5_temp_sensor/src/main.c	(revision 349)
@@ -84,11 +84,4 @@
 extern int bt_bnep_mode;
 /* PANU向けリモートアドレス */
-// BUFFALLO
-//bd_addr_t remote_addr = { 0x00,0x1B,0xDC,0x04,0x5C,0x2D };
-// Raspberry Pi 3
-//bd_addr_t remote_addr = {0xB8,0x27,0xEB,0x10,0x6D,0x60};
-// PRINCETON
-//bd_addr_t remote_addr = {0x00,0x1B,0xDC,0x06,0x6E,0x98};
-// ELECOM
 bd_addr_t remote_addr = {0x00,0x1B,0xDC,0x09,0x27,0x26};
 #endif
Index: /asp3_tinet_ecnl_rx/trunk/app6_hot_water_pot/src/main.c
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app6_hot_water_pot/src/main.c	(revision 348)
+++ /asp3_tinet_ecnl_rx/trunk/app6_hot_water_pot/src/main.c	(revision 349)
@@ -84,11 +84,4 @@
 extern int bt_bnep_mode;
 /* PANU向けリモートアドレス */
-// BUFFALLO
-//bd_addr_t remote_addr = { 0x00,0x1B,0xDC,0x04,0x5C,0x2D };
-// Raspberry Pi 3
-//bd_addr_t remote_addr = {0xB8,0x27,0xEB,0x10,0x6D,0x60};
-// PRINCETON
-//bd_addr_t remote_addr = {0x00,0x1B,0xDC,0x06,0x6E,0x98};
-// ELECOM
 bd_addr_t remote_addr = {0x00,0x1B,0xDC,0x09,0x27,0x26};
 #endif
Index: /asp3_tinet_ecnl_rx/trunk/app7_buzzer/src/main.c
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/app7_buzzer/src/main.c	(revision 348)
+++ /asp3_tinet_ecnl_rx/trunk/app7_buzzer/src/main.c	(revision 349)
@@ -84,11 +84,4 @@
 extern int bt_bnep_mode;
 /* PANU向けリモートアドレス */
-// BUFFALLO
-//bd_addr_t remote_addr = { 0x00,0x1B,0xDC,0x04,0x5C,0x2D };
-// Raspberry Pi 3
-//bd_addr_t remote_addr = {0xB8,0x27,0xEB,0x10,0x6D,0x60};
-// PRINCETON
-//bd_addr_t remote_addr = {0x00,0x1B,0xDC,0x06,0x6E,0x98};
-// ELECOM
 bd_addr_t remote_addr = {0x00,0x1B,0xDC,0x09,0x27,0x26};
 #endif
Index: /asp3_tinet_ecnl_rx/trunk/ntshell/src/syscall.c
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/ntshell/src/syscall.c	(revision 348)
+++ /asp3_tinet_ecnl_rx/trunk/ntshell/src/syscall.c	(revision 349)
@@ -172,5 +172,4 @@
 
 long SYS_futex() {
-	int futex(int *uaddr, int op, int val, const struct timespec *timeout, int *uaddr2, int val3);
 	return no_implement("futex\n");
 }